﻿<AML>
 <Item type="Method" id="0B8D0727F0C045FF974E0DACF28B2A6D" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_getCompanyInfo
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Getting Company Information.

            Hooks:
                Called by:	acc_allocation_report
                            acc_BalanceSheet_Accrual_sp
                            acc_BalanceSheet_Cash_sp
                            acc_balancesheet_sp_call
                            acc_cashbook_tran_StoreProcedure
                            acc_general_ledger_sp
                            acc_gst_schedule_rpt_call
                            acc_journal_register_report_call
                            acc_ProfitandLoss_Accrual_sp
                            acc_ProfitandLoss_Cash_sp
                            acc_set_default_sequence
                            acc_sr_zr_oss_exempt_rpt
                            acc_trial_balance_sp
                            SOP_Import_CI_Excel_Data
                            SOP_Import_DeliveryOrderExcel
                            SOP_Import_SaleInvoiceExcel_Data
                            sop_Import_SaleOrderExcel2
                            sop_import_ServiceOrderExcel
                            sop_import_Ser_Order_Excel_Well
            Inputs:
                <describe the inputs expected by the server method>

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_getCompanyInfo";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                Item getCompany = myInnovator.newItem("erp_company_setup", "get");
                getCompany = getCompany.apply();
                getCompany = getCompany.getItemByIndex(0);
                result = getCompany;
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>acc_getCompanyInfo</name>
 </Item>
</AML>